

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}

local settingsUser = readJsonFile("/mods/sirenmod/config/settings.json")
local isRadiatorDamaged = 0
local isAlarm = false
local alarmDelay = 0
local toggleHorn = 0
local isAlarmEnabled = false
local velocity = 0
local crashDelay = 0
local isSignalOn = false
local engineBeepSound = false
local smokeSound = obj:createSFXSource('art/sound/smoke.ogg', 'AudioDefaultLoop3D', "SmokeSound", v.data.refNodes[0].ref)
--========================================================INITILIZATION==========================================================
local function onInit()
	obj:setVolumePitch(smokeSound, 0, 1)
	engineBeepSound = false
	isRadiatorDamaged = 0
	isAlarm = false
	crashDelay = 0
	alarmDelay = 0
	if electrics.values.hazard_enabled == 1 then electrics.toggle_warn_signal() end -- Disable the hazard light on vehicle reset
	if electrics.values.signal_left_input == 1 then electrics.toggle_left_signal() end -- Same for left signal
	if electrics.values.signal_right_input == 1 then electrics.toggle_right_signal() end -- Same for right signal
end
--========================================================INITILIZATION==========================================================







--================================================================VALUES==================================================================
local reversegear = 	obj:createSFXSource('art/sound/reversegear.ogg', 	     'AudioDefaultLoop3D',  "reversegear",		 v.data.refNodes[0].ref)
local alarm  = 			obj:createSFXSource('art/sound/alarm.ogg',  			 'AudioDefaultLoop3D',  "alarm",			 v.data.refNodes[0].ref)
local metal1 = 			obj:createSFXSource('art/sound/metal1.ogg', 			 'AudioDefault3D', 		"metal1", 		     v.data.refNodes[0].ref)
local metal2 = 			obj:createSFXSource('art/sound/metal2.ogg', 			 'AudioDefault3D', 		"metal2",		     v.data.refNodes[0].ref)
local handbrakeLock = 	obj:createSFXSource('art/sound/handbrakelock.ogg', 	 	 'AudioDefault3D', 		"handbrakeLock",	 v.data.refNodes[0].ref)
local handbrakeUnlock = obj:createSFXSource('art/sound/handbrakeunlock.ogg',	 'AudioDefault3D', 		"handbrakeUnlock"  , v.data.refNodes[0].ref)
local lights = 			obj:createSFXSource('art/sound/lights.ogg', 			 'AudioDefault3D', 		"lights", 			 v.data.refNodes[0].ref)
local shift1 =    		obj:createSFXSource('art/sound/shift1.ogg',       		 'AudioDefault3D', 		"shift1", 			 v.data.refNodes[0].ref)
local shift2 =    		obj:createSFXSource('art/sound/shift2.ogg',       		 'AudioDefault3D', 		"shift2", 			 v.data.refNodes[0].ref)
local shift3 =    		obj:createSFXSource('art/sound/shift3.ogg',       		 'AudioDefault3D', 		"shift3", 			 v.data.refNodes[0].ref) 
local beep = 			obj:createSFXSource('art/sound/beep.ogg', 				 'AudioDefaultLoop3D',  "beep",				 v.data.refNodes[0].ref)
local rfan = 			obj:createSFXSource('art/sound/radiatorfan.ogg', 		 'AudioDefaultLoop3D',  "rfan",				 v.data.refNodes[0].ref)
local brake = 			obj:createSFXSource('art/sound/brake.ogg', 				 'AudioDefaultLoop3D',  "brake",			 v.data.refNodes[0].ref)
local crash1  = 		sounds.createSFXSource('art/sound/crashsounds/crash1.ogg',  'AudioDefault3D',   "crash1",			 v.data.refNodes[0].ref)
local crash2  = 		sounds.createSFXSource('art/sound/crashsounds/crash2.ogg',  'AudioDefault3D',   "crash2",			 v.data.refNodes[0].ref)
local crash3  = 		sounds.createSFXSource('art/sound/crashsounds/crash3.ogg',  'AudioDefault3D',   "crash3",			 v.data.refNodes[0].ref)
local crash4  = 		sounds.createSFXSource('art/sound/crashsounds/crash4.ogg',  'AudioDefault3D',   "crash4",			 v.data.refNodes[0].ref)
local crash5  = 		sounds.createSFXSource('art/sound/crashsounds/crash5.ogg',  'AudioDefault3D',   "crash5",			 v.data.refNodes[0].ref)
local crash6  = 		sounds.createSFXSource('art/sound/crashsounds/crash6.ogg',  'AudioDefault3D',   "crash6",			 v.data.refNodes[0].ref)
local crash7  = 		sounds.createSFXSource('art/sound/crashsounds/crash7.ogg',  'AudioDefault3D',   "crash7",			 v.data.refNodes[0].ref)
local crash8  = 		sounds.createSFXSource('art/sound/crashsounds/crash8.ogg',  'AudioDefault3D',   "crash8",			 v.data.refNodes[0].ref)
local crash9  = 		sounds.createSFXSource('art/sound/crashsounds/crash9.ogg',  'AudioDefault3D',   "crash9",			 v.data.refNodes[0].ref)
local crash10 = 		sounds.createSFXSource('art/sound/crashsounds/crash10.ogg', 'AudioDefault3D',   "crash10",			 v.data.refNodes[0].ref)
--================================================================VALUES==================================================================







--============================================ALARM SOUND============================================
local alarmPulse = false
local alarmTimerThreshold = 0.4
local alarmTimer = 0
local function generateAlarmPulse(dt)

	  alarmTimer = alarmTimer + dt -- Some code took from the main game
  if alarmTimer > alarmTimerThreshold then
    alarmPulse = not alarmPulse
    alarmTimer = 0

	if isAlarm == true and alarmDelay < tonumber(settingsUser.AlarmDelay) then -- If alarm enabled		
		obj:setVolume(alarm, tonumber(settingsUser.AlarmVolume)) -- Set volume

		if toggleHorn < 3 then -- Each blinker tick
			toggleHorn = toggleHorn + 1 -- +1 each tick to stop the horn for somes second each 3 ticks
			electrics.toggle_lights() -- More realism :D
			alarmDelay = alarmDelay + 1 -- Alarm play until this value reach the user delay (in settings)
						if toggleHorn == 1 then electrics.horn(true) end -- Enable horn
		elseif toggleHorn > 2 and toggleHorn < 5 then -- Each 3 blinker ticks
			toggleHorn = toggleHorn + 1
			electrics.horn(false) -- Disable horn
		else
			toggleHorn = 0
		end

	else
		if isAlarm == true then electrics.horn(off) isAlarm = false end
		obj:setVolume(alarm, 0) -- Disable alarm when delay finished or not active
	end	
	
	
	
  end
end
--============================================ALARM SOUND============================================







--==================================================================CRASH SOUND==========================================================
local function crash(breakNode, vol)
	if settingsUser.CrashSound == "true" and settingsUser.CrashSound ~= nil then -- If user enabled crash sound
		if crashDelay > 0.1 then -- Verify the delay to avoid few crash sounds playing at the same time
			sounds.playSoundOnceAtNode("crash"..math.random(10), breakNode, vol*4) end
			print(vol*5)
			crashDelay = 0 -- Reset the delay			
			if velocity < 5 and electrics.values.rpm < 5 and electrics.values.rpm ~= 0 and engineBeepSound == false then -- If vehicle stopped and engine not dead 
			isAlarm = true -- Enable alarm (line 127)
			if electrics.values.hazard_enabled == 0 then electrics.toggle_warn_signal() end -- Toggle warn signal if not already enabled
			
		end
	end
end
--==================================================================CRASH SOUND==========================================================







--=====================VALUES=======================
local fogMem
local gearMem
local lightsMem
local brakeSoundSwitch  = false
local rand
local waterTempVolume = 0
local fanPitch = 0
local fanVolume = 0
local frictionDelay = 0
local soundRev = 0
local brakeFadeIn = 0
local brakeFadeOut = 1
local brakeDuration = 0
local isBrakeRand = false
local randBrake = 0
local isBrakeSquealEnabled = false
local nodesList = {}
local frictionVolume = 0
local frictionPitch = 0
local nodeVelVector
local nodeVel
--=====================VALUES=======================







local function onUpdate(dt) --ONUPDATE OPEN


	velocity = vec3(obj:getVelocity()):length() -- Get velocity

		
--==========================================================REVERSE GEAR SOUND==========================================================
	if electrics.values.gearIndex < 0 and settingsUser.ReverseGear == "true" and settingsUser.ReverseGear ~= nil then -- If user enabled reverse sound
																													  -- If gearIndex = reverse
		soundRev = electrics.values.wheelspeed/15 -- Pitch and volume = wheels speed / 15
		obj:setVolumePitch(reversegear, soundRev, soundRev) -- Set volume
	else
		obj:setVolumePitch(reversegear, 0, 1) -- Else if gearIndex =/= reverse set volume to 0
	end
--==========================================================REVERSE GEAR SOUND==========================================================
	





	
--==========================================================ALARM SOUND==========================================================
	if settingsUser.AlarmSound == "true" and settingsUser.AlarmSound ~= nil then -- If user enabled alarm sound
		generateAlarmPulse(dt) -- Use same ticking as blinker
	end
--==========================================================ALARM SOUND==========================================================
	
	
	
	
	
	
	
	if drivingSounds.cameraMode == "dash" then --DASH OPEN
	
	
--============================================SHIFT SOUND============================================== (DASH)
		if settingsUser.ShifterSound == "true" and settingsUser.ShifterSound ~= nil then -- If user enabled shift sounds
			if gearMem ~= electrics.values.gearIndex then -- If the gear change
				rand = math.random(3) -- Randomly play one of the 3 sounds
				if rand == 1 then 
					obj:setVolume(shift1, tonumber(settingsUser.ShifterSoundVolume))
					obj:playSFX(shift1)
				end
				if rand == 2 then 
					obj:setVolume(shift2, tonumber(settingsUser.ShifterSoundVolume))
					obj:playSFX(shift2)
				end
				if rand == 3 then 
					obj:setVolume(shift3, tonumber(settingsUser.ShifterSoundVolume))
					obj:playSFX(shift3)
				end
			end
			gearMem = electrics.values.gearIndex		
		end
--============================================SHIFT SOUND============================================== (DASH)







--========================================HANDBRAKE BRAKE SOUND========================================== (DASH)		*
		if settingsUser.HandbrakeSound == "true" and settingsUser.HandbrakeSound ~= nil then -- If user enabled handbrake sounds
			if input.parkingbrake == 1 and brakeSoundSwitch == false then --If the handbrake is on 
				obj:setVolume(handbrakeLock, tonumber(settingsUser.HandbrakeSoundVolume))
				obj:playSFX(handbrakeLock)
				brakeSoundSwitch = true -- To avoid sound playing more than 1 time
			elseif input.parkingbrake == 0 and brakeSoundSwitch == true then -- Else if the handbrake is off
				obj:setVolume(handbrakeUnlock, tonumber(settingsUser.HandbrakeSoundVolume))
				obj:playSFX(handbrakeUnlock)
				brakeSoundSwitch = false -- To avoid sound playing more than 1 time
			end
		end
--========================================HANDBRAKE BRAKE SOUND========================================== (DASH)	







	else
		isSignalOn = false --Prevent signal sound to be played on vehicle reset
		if input.parkingbrake == 1 then brakeSoundSwitch = true end --Prevent handbrake sound to be played on vehicle reset
		if input.parkingbrake == 0 then brakeSoundSwitch = false end
	end --DASH CLOSE





	
	
--==================================================LIGHTS SOUND=======================================================	
	if settingsUser.LightsSound == "true" and settingsUser.LightsSound ~= nil then -- If user enabled lights sound
		if electrics.values.lights_state ~= lightsMem or electrics.values.fog ~= fogMem then -- If light state change
			obj:setVolume(lights, tonumber(settingsUser.LightsSoundVolume))
			obj:playSFX(lights)
		end	
		lightsMem = electrics.values.lights_state -- Set latest light state to check if the light state change
		fogMem = electrics.values.fog
	end
	
--==================================================LIGHTS SOUND=======================================================







--=======================================================ENGINE BEEP SOUND=========================================================
	if settingsUser.EngineBeepSound == "true" and settingsUser.EngineBeepSound ~= nil then -- If user enabled engine beep sound
		if drivingSounds.cameraMode == "dash" and engineBeepSound == true then -- If first person and engine broken
			obj:setVolumePitch(beep, tonumber(settingsUser.EngineBeepSoundVolume), 1) -- Play sound
		else
			obj:setVolumePitch(beep, 0, 1) -- Else set volume to 0
		end
	end
--=======================================================ENGINE BEEP SOUND=========================================================	







--================================================================RADIATOR FAN SOUND================================================================	
	if settingsUser.RadiatorFanSound == "true" and settingsUser.RadiatorFanSound ~= nil then -- If user enabled fan sound
		if isRadiatorDamaged == 0 then
			if electrics.values.watertemp ~= nil and electrics.values.watertemp > 93 and electrics.values.rpm > 1 then 
				waterTempVolume = electrics.values.watertemp/100 -- Define the volume and the pitch of the fan
				
				if fanVolume < waterTempVolume then -- Fade in sound
					obj:setVolumePitch(rfan, fanVolume/4, fanPitch)
					fanVolume = fanVolume + 0.01 -- Increase fan volume slowly to have fade effect
					fanPitch = fanVolume -- Set fan pitch
					if fanPitch > 1.3 then fanPitch = 1.3 end -- Fan pitch max value
				else -- Not fading sound
					fanPitch = waterTempVolume -- Not fading fan pitch
					if fanPitch > 1.3 then fanPitch = 1.3 end -- Fan pitch max value
					obj:setVolumePitch(rfan, waterTempVolume/2, fanPitch)
				end		
			else -- Fade out sound (when fan is stopping)
				obj:setVolumePitch(rfan, fanVolume/1.5, fanPitch)
				if fanVolume >= 0 then fanVolume = fanVolume - 0.007 end -- If fan volume is not 0 then decrease fan volume slowly
				if fanPitch >= 0 then fanPitch = fanPitch - 0.007 end -- If fan pitch is not 0 then decrease fan volume slowly
			end
		elseif isRadiatorDamaged == 1 then -- If radiator is damaged
			obj:setVolumePitch(rfan, 0, 1) -- Stop fan sound because it's broken
			gui.message({txt="vehicle.drivetrain.deviceBroken", context={deviceName="Radiator fan"}}, 10, "damage.device.") -- Send message to UI
			isRadiatorDamaged = 2 -- Avoid this to run more than 1 time
		end
	end
--================================================================RADIATOR FAN SOUND================================================================	



    if crashDelay < 0.2 then crashDelay = crashDelay + dt end

	
	
--=========================================================BRAKE SOUND===========================================================
	if settingsUser.BrakeSqueal == "true" and settingsUser.BrakeSqueal ~= nil then -- If user enabled brake squeal sound
		if isBrakeSquealEnabled == true then -- If sound enabled from the app
			if electrics.values.brake_input > 0.75 and electrics.values.gearIndex > 0 and electrics.values.wheelspeed > 1 then		
			--If brake is pressed more then 75% and not in reverse gear and wheels are not blocked
				brakeFadeIn = brakeFadeIn + dt -- dt = time in seconds
				if brakeFadeIn < tonumber(settingsUser.BrakeSquealVolume)/4 then -- Volume / 4
					obj:setVolume(brake, brakeFadeIn * 4)
				end
				
				brakeDuration = brakeDuration + dt -- Duration of the brake in seconds
				
				if isBrakeRand == false then -- Create a random number between 0 and 3
					randBrake = math.random()+math.random()+math.random()
					isBrakeRand = true
				end			
				
				if brakeDuration > randBrake then -- In the brake duration is higher than the random number
					brakeFadeOut = brakeFadeOut + dt		
					if 1-brakeFadeOut*4 > 0 then 
						obj:setVolume(brake, 1-brakeFadeOut * 4) -- Then fade out and stop the sound
					else
						obj:setVolume(brake, 0)
					end
				else
					brakeFadeOut = 0
				end
				
			else
			
				brakeFadeOut = brakeFadeOut + dt -- Fading out the sound	
				if tonumber(settingsUser.BrakeSquealVolume)/4-brakeFadeOut*4 > 0 then -- Volume / 4 - brakeFadeOut * 4  
					obj:setVolume(brake, 1-brakeFadeOut * 4)
				else
					obj:setVolume(brake, 0)
				end
				brakeFadeIn = 0 -- Reset some values...
				isBrakeRand = false
				brakeDuration = 0
				
			end
		else 
			obj:setVolume(brake, 0) -- If brake disabled with the app then stop the sound
		end	
	end
--=========================================================BRAKE SOUND===========================================================




	

	
--==========================================================FRICTION SOUND 1============================================================	
	
	if frictionDelay < 0.1 then frictionDelay = frictionDelay + dt -- If friction delay is not finished
	elseif frictionDelay > 0.1 and frictionDelay < 3 then -- If friction delay is finished
		for k, v in pairs(nodesList) do -- List all nodes already in the list
			obj:deleteSFXSource(v) -- Delete them all from memory
		end
		nodesList = {} -- Clear nodes list
		frictionDelay = 5 -- Set friction delay to 5 to avoid this to run more than 1 time
	end

	if next(nodesList) ~= nil then -- If nodesList is not empty
		for k, v in pairs(nodesList) do
			nodeVelVector = obj:getNodeVelocityVector(k) -- Get node velocity vector (x,y,z)
			-- Convert it to normal velocity
			nodeVel = math.sqrt(nodeVelVector.x*nodeVelVector.x + nodeVelVector.y*nodeVelVector.y + nodeVelVector.z*nodeVelVector.z)
			frictionPitch = nodeVel/20 -- Pitch = velocity / 20
			if frictionPitch < 1 then frictionPitch = 1 -- Avoid friction pitch to get under 1
			elseif frictionPitch > 1.4 then frictionPitch = 1.4 end -- Avoid friction pitch to get over 1.4
			frictionVolume = nodeVel/50 -- Volume = velocity / 20
			if frictionVolume > 0.8 then frictionVolume = 0.8 end -- Avoid friction volume to get over 1
			obj:setVolumePitch(v, frictionVolume, frictionPitch)		
		end
	end
--==========================================================FRICTION SOUND 1============================================================	
	
	
	


	
	
end --ONUPDATE CLOSE



--============================================================FRICTION SOUND 2==============================================================
local tempSound
local function friction(nodeID, nodePos) -- If spark particles are created mean user scratch a wall
	if settingsUser.ScratchSound == "true" and settingsUser.ScratchSound ~= nil then -- If user enabled scratch sound
		frictionDelay = 0 -- Set friction delay to 0
		if next(nodesList) == nil then -- If nodesList is empty
			if nodesList[nodeID] == nil then -- If nodesList does not contain already the node
				tempSound = obj:createSFXSource('art/sound/scrape.ogg', 'AudioDefaultLoop3D', tostring(nodeID), nodeID) -- Create sound
				nodesList[nodeID] = tempSound -- Add the node and the sound to the list
			end		
		else -- If nodesList is not empty
			for k, v in pairs(nodesList) do -- List all nodes already in the list
				local tempPos = vec3(obj:getNodePosition(k)) -- Get node list position to check if node is not too close from the other node
				-- If node is not too close from the other node (4 meters)
				if tempPos.x > nodePos.x+4 and tempPos.x < nodePos.x+4 and tempPos.y > nodePos.y+4 and tempPos.y < nodePos.y+4 and tempPos.z > nodePos.z+4 and tempPos.z < nodePos.z+4 then 						
					if nodesList[nodeID] == nil then -- If nodesList does not contain already the node
						tempSound = obj:createSFXSource('art/sound/scrape.ogg', 'AudioDefaultLoop3D', tostring(nodeID), nodeID) -- Create sound
						nodesList[nodeID] = tempSound -- Add the node and the sound to the list
					end							
				end
			end	-- Too many end :D
		end
	end
end
--============================================================FRICTION SOUND 2==============================================================







--==========================================================ENGINE SMOKE SOUND============================================================
local function smoke()
	if settingsUser.EngineSmokeSound == "true" and settingsUser.EngineSmokeSound ~= nil then -- If user enabled engine smoke sound
		obj:setVolumePitch(smokeSound, tonumber(settingsUser.EngineSmokeSoundVolume), 1) -- Toggle smoke sound
		if isRadiatorDamaged == 0 then isRadiatorDamaged = 1 end -- Set isRadiatorDamaged to 1 to break the fan and stop fan sound
	end
end
--==========================================================ENGINE SMOKE SOUND============================================================







--===============ENGINE BEEP SOUND=================	
local function engineBeep()
	engineBeepSound = true
end
--===============ENGINE BEEP SOUND=================







--===============BRAKE SQUEAL SOUND=================	
local function toggleBrakeSqueal(value)
	isBrakeSquealEnabled = value
end
--===============BRAKE SQUEAL SOUND=================	







--===============ALARM SOUND=================	
local function toggleAlarm(value)
		isAlarmEnabled = value
end

local function enableAlarm()
	if isAlarmEnabled == true then
		isAlarm = true
	end
end
--===============ALARM SOUND=================	



M.crash              = crash
M.enableAlarm        = enableAlarm
M.toggleAlarm        = toggleAlarm
M.toggleBrakeSqueal  = toggleBrakeSqueal
M.friction      	 = friction
M.engineBeep 		 = engineBeep
M.jsonInit	    	 = jsonInit
M.smoke 			 = smoke
M.onUpdate	    	 = onUpdate
M.onReset 			 = onInit
M.updateGFX	    	 = onUpdate

return M